<?php
require_once "PaytmChecksum.php";


class PHPClass
{
    function getToken()
    {
        $url = tokenRest;
        //$encPass  = 'password';
        $encPass  = $this->encryptPassword('password');
        $fields = array(
            'client_id' => 'publicclient',
            'client_secret' => '$edu#pub@21',
            'grant_type' => 'password',
            'username' => 'PUBLIC_PORTAL_USER',
            'portal_code' => 'PUBLIC_PORTAL',
            'code' => 'PUBLIC_PORTAL',
            'password' => $encPass,
        );

        $payload = http_build_query($fields);

        /*
            create the content-length header string - use `strlen` to get the length!
        */
        $contentlength = strlen($payload);

        $fields_string = "";

        //url-ify the data for the POST
        foreach ($fields as $key => $value) {
            $fields_string .= $key . '=' . $value . '&';
        }
        rtrim($fields_string, '&');

        //open connection
        $ch = curl_init();

        //set the url, number of POST vars, POST data
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_POST, $contentlength);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $payload);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
        curl_setopt(
            $ch,
            CURLOPT_HTTPHEADER,
            array(
                'Accept: application/json'
            )
        );
        //execute post
        $result = curl_exec($ch);
        curl_close($ch);
        return $result;
    }


    public function encryptPassword($plaintext)
    {
        include_once('./phpseclib/Crypt/RSA.php');

        // use phpseclib\Crypt\RSA;

        $public_key = PUBLIC_KEY;
        $key = "-----BEGIN PUBLIC KEY-----\n" . wordwrap($public_key, 64, "\n", true) . "\n-----END PUBLIC KEY-----";

        $rsa = new Crypt_RSA();
        $rsa->loadKey($public_key); // public key

        $rsa->setEncryptionMode(CRYPT_RSA_ENCRYPTION_PKCS1);
        $ciphertext = $rsa->encrypt($plaintext);

        //print_r($ciphertext);

        $data = base64_encode($ciphertext);
        return $data;
    }

    function getTransactionToken($callbackUrl, $amount, $generatedOrderID, $merchantReference)
    {

        // $generatedOrderID = "PYTM_BLINK_".time();
        $callbackUrl = domainURL . '/' . $callbackUrl;
        $paytmParams["body"] = array(
            "requestType"   => "Payment",
            "mid"           => PAYTM_MID,
            "websiteName"   => PAYTM_WEBSITE,
            "orderId"       => $generatedOrderID,
            "callbackUrl"   => $callbackUrl,
            "txnAmount"     => array(
                "value" => $amount,
                "currency" => "INR",
            ),
            "userInfo"      => array(
                "custId" => $merchantReference,
            ),
            "extendInfo"    => array(
                "mercUnqRef"    => $merchantReference
            )
        );

        $generateSignature = PaytmChecksum::generateSignature(json_encode($paytmParams['body'], JSON_UNESCAPED_SLASHES), PAYTM_MERCHANT_KEY);

        $paytmParams["head"] = array(
            "signature" => $generateSignature
        );

        $url = PAYTM_ENVIRONMENT . "/theia/api/v1/initiateTransaction?mid=" . PAYTM_MID . "&orderId=" . $generatedOrderID;
        $getcURLResponse = $this->getcURLRequest($url, $paytmParams);
        // echo "<pre>";
        //     echo $url;print_r($paytmParams);
        // print_r($getcURLResponse);
        if (!empty($getcURLResponse['body']['resultInfo']['resultStatus']) && $getcURLResponse['body']['resultInfo']['resultStatus'] == 'S') {
            $result = array('success' => true, 'orderId' => $generatedOrderID, 'txnToken' => $getcURLResponse['body']['txnToken'], 'amount' => $amount, 'message' => $getcURLResponse['body']['resultInfo']['resultMsg'], 'mercUnqRef' => $merchantReference);
        } else {
            $result = array('success' => false, 'orderId' => $generatedOrderID, 'txnToken' => '', 'amount' => $amount, 'message' => $getcURLResponse['body']['resultInfo']['resultMsg'], 'mercUnqRef' => $merchantReference);
        }
        return $result;
    }


    function getcURLRequest($url, $postData = array(), $headers = array("Content-Type: application/json"))
    {

        $post_data_string = json_encode($postData, JSON_UNESCAPED_SLASHES);

        $ch = curl_init($url);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $post_data_string);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_HTTPHEADER, array("Content-Type: application/json"));
        $response = curl_exec($ch);
        return json_decode($response, true);
    }

    function getSiteURL()
    {
        $actual_link = (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] === 'on' ? "https" : "http") . "://" . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'];
        return str_replace('config.php', '', $actual_link);
    }

    function secMe($options)
    {
        $nonce = "";
        if ($options['public_key'] != '') {
            $tkn = $options['access_token'];
            $tknHash = hash('sha256', $tkn);
            $tknPramHash32 = (strlen($tknHash) > 16) ? substr($tknHash, 0, 16) : $tknHash;


            $timeInMillSec = round(microtime(true) * 1e6);
            $timeHash = hash('sha256', $timeInMillSec);
            $nanoPramHash32 = (strlen($timeHash) > 16) ? substr($timeHash, 0, 16) : $timeHash;

            $urlParams = "BLANK";
            if ($options  && $options['params']) {
                $options['params'] = str_replace('%20', ' ', $options['params']);
                $options['params'] = str_replace('%2C', ',', $options['params']);
                $urlParams = $this->sumAscVal($options['params']);
            }

            $urlParamHash = hash('sha256', $urlParams);
            $urlPramHash32 = (strlen($urlParamHash) > 16) ? substr($urlParamHash, 0, 16) : $urlParamHash;

            $jsonData = $options['jsonData'];
            $bodyJsonObj = [];
            if ($jsonData) {
                $bodyJsonObj = is_string($jsonData) ? json_decode($jsonData, true) : $jsonData;
            }
            $bodyParams = "BLANK";
            if (count($bodyJsonObj) > 0) {
                $bodyParams = json_encode($bodyJsonObj);
                $bodyParams = $this->sumAscVal($bodyParams);
            }
            $bodyParamHash = hash('sha256', $bodyParams);
            $bodyParamHash32 = (strlen($bodyParamHash) > 16) ? substr($bodyParamHash, 0, 16) : $bodyParamHash;
            $finalHashString = $tknPramHash32 . $nanoPramHash32 . $urlPramHash32 . $bodyParamHash32;
            $nonce_key = $options['public_key'];
            $nonce = $this->encrypt($finalHashString, $nonce_key);

            return $nonce;
        } else {
            return $nonce;
        }
    }
    function sumAscVal($jsonString)
    {
        $sum = 0;
        for ($i = 0; $i < strlen($jsonString); $i++) {
            $sum += ord($jsonString[$i]);
        }
        return $sum;
    }

    function encrypt($encryptText, $publicKey)
    {
        include_once('./phpseclib/Crypt/RSA.php');
        $rsa = new Crypt_RSA();
        $rsa->setEncryptionMode(CRYPT_RSA_ENCRYPTION_PKCS1);
        $rsa->loadKey($publicKey);


        $ciphertext = $rsa->encrypt($encryptText);

        return base64_encode($ciphertext);
    }

    function decrypt($encryptedText, $privateKey)
    {
        include_once('./phpseclib/Crypt/RSA.php');
        $rsa = new Crypt_RSA();
        $rsa->loadKey($privateKey);


        $ciphertext = base64_decode($encryptedText);


        $decryptedText = $rsa->decrypt($ciphertext);


        return $decryptedText;
    }
}
