<!DOCTYPE html>
<html>
    <head>
        <title>Paytm Payment Gateway</title>
        <link rel="stylesheet" href="css/bootstrap.min.css" crossorigin="anonymous">
        <style type="text/css">
            .footer-main{
                position: absolute;
                bottom: 0;
                text-align: center;
                background: #dddddd42;
            }
            #loader{
              position: fixed;
              left: 0px;
              top: 0px;
              width: 100%;
              height: 100%;
              z-index: 9999;
              background: url('image/Loader.gif')
                          50% 50% no-repeat rgb(249,249,249);
            }
        </style>
    </head>
    <body>
        <div id="loader"></div>
        <?php
            require_once "PaytmChecksum.php";
            error_reporting(E_ALL);
            include('Logger.php');
            Logger::notice("Applicant Declaration Payment");
            Logger::info(serialize($_POST));
            include("db_config.php");
            include("functionclass.php");
            $ClassObject = new PHPClass();
            $token = $ClassObject->getToken();
            $token = json_decode($token);
            $authorization = "Authorization: Bearer " . $token->access_token;
            if(isset($_POST['TXNID']))
            {
                $logQuery = "SELECT * FROM information_schema.tables WHERE table_schema = '".DBNAME."' AND table_name = 'payment_log' LIMIT 1";
                $select = mysqli_query($conn, $logQuery);

                if (mysqli_num_rows($select) > 0)
                {
                    $sql = "SELECT * FROM payment_log where txn_id='" . $_POST['TXNID']."'";
                    $selectLog = mysqli_query($conn, $sql);
                    $result = array();
                    if (mysqli_num_rows($selectLog) == 0)
                    {
                        $responceJson = json_encode($_POST);
                        $query = "INSERT INTO payment_log (txn_id, responce) VALUES ('" . $_POST['TXNID'] . "', '".$responceJson."')";
                        $insert = mysqli_query($conn, $query);
                    }
                }
            }
            $academyLocationId = $_POST['ACADEMYLOCATIONID'];
            $orderId = $_POST['ORDERID'];
            $orderIdArr = explode("-", $orderId);
            $status = $_POST["STATUS"];
            $transactionId = $_POST['TXNID'];
            $paymentId = $orderIdArr[0];
            $options = array(
                'public_key' => $token->nonsec,
                'params' => 'isActive=' . IS_ACTIVE . '&academyLocationIds=' . $academyLocationId,
                'jsonData' => '',
                'access_token' => isset($token->access_token)?$token->access_token:'',
            );
            $nonce = $ClassObject->secMe($options);
            $url = baseURL . paytmGatewayDetailsAPI . '?isActive=' . IS_ACTIVE . '&academyLocationIds=' . $academyLocationId;
            $ch = curl_init($url);
            curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "GET");
            curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_TIMEOUT, 120);
            curl_setopt(
                $ch,
                CURLOPT_HTTPHEADER,
                array(
                    'Content-Type: application/json',
                    $authorization,
                    'nonce: '.$nonce
                )
            );

            $resultcurl = curl_exec($ch);
            $responceERPGateway = json_decode($resultcurl);
            if(isset($responceERPGateway->merchantKey) && isset($responceERPGateway->mid))
            {
                define('PAYTM_ENVIRONMENT', $responceERPGateway->transactionURL);
                define('PAYTM_MID', $responceERPGateway->mid);
                define('PAYTM_MERCHANT_KEY', $responceERPGateway->merchantKey);
                define('PAYTM_WEBSITE', $responceERPGateway->website);

                $checksum = (!empty($_POST['CHECKSUMHASH'])) ? $_POST['CHECKSUMHASH'] : '';
                            unset($_POST['CHECKSUMHASH']);
                unset($_POST['ACADEMYLOCATIONID']);
                $verifySignature = PaytmChecksum::verifySignature($_POST, PAYTM_MERCHANT_KEY, $checksum);

                if ($_POST && $verifySignature != "")
                {
                    /*****   Check Transaction Status Check   *****/
                    $paytmParams = array();
                    $paytmParams["body"] = array("mid" => PAYTM_MID,"orderId" => $orderId);
                    $checksum = PaytmChecksum::generateSignature(json_encode($paytmParams["body"], JSON_UNESCAPED_SLASHES), PAYTM_MERCHANT_KEY);
                    $paytmParams["head"] = array("signature" => $checksum);
                    $postData = json_encode($paytmParams, JSON_UNESCAPED_SLASHES);
                    $url = $responceERPGateway->transactionStatusURL;
                    $options = array(
                        'public_key' => $token->nonsec,
                        'params' => '',
                        'jsonData' => $postData,
                        'access_token' => isset($token->access_token)?$token->access_token:'',
                    );
                    $nonce = $ClassObject->secMe($options);
                    $ch = curl_init($url);
                    curl_setopt($ch, CURLOPT_POST, 1);
                    curl_setopt($ch, CURLOPT_POSTFIELDS, $postData);
                    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                    curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json','nonce: '.$nonce));
                    $response = curl_exec($ch);
                    $response = json_decode($response, true);
                    $status = $response['body']['resultInfo']['resultStatus'];
                    /*****   End Check Transaction Status Check   *****/
                    if (!empty($paymentId))
                    {
                        $sql = "SELECT * FROM applicant_declaration_payment where id=" . $paymentId;
                        $select = mysqli_query($conn, $sql);
                        $result = mysqli_fetch_assoc($select);
                    }
                    $currency = isset($result['currency']) ? $result['currency'] : "INR";
                    $onlinePaymentId = isset($result['onlinePaymentId']) ? $result['onlinePaymentId'] : '';
                    $amount = isset($result['amount']) ? $result['amount'] : 0;
                    if($onlinePaymentId && $amount > 0)
                    {
                        $applicantId = $result['applicantId'];
                        $moduleId = $result['moduleId'];
                        $setupId = $result['setupId'];
                        if ($status == "TXN_SUCCESS" && isset($result['formSubmissionStatus']) && $result['formSubmissionStatus'] != 1)
                        {
                            $options = array(
                                'public_key' => $token->nonsec,
                                'params' => 'applicationId='.$applicantId.'&currentDate'.date('Y-m-d'),
                                'jsonData' => '',
                                'access_token' => isset($token->access_token)?$token->access_token:'',
                            );
                            $nonce = $ClassObject->secMe($options);
                            $urlFormSubmit = baseURL.ApplicantFormSubmit.'?applicationId='.$applicantId.'&currentDate'.date('Y-m-d');
                            $ch = curl_init($urlFormSubmit);
                            curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "GET");
                            curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);
                            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
                            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                            curl_setopt($ch, CURLOPT_TIMEOUT, 120);
                            curl_setopt(
                                $ch,
                                CURLOPT_HTTPHEADER,
                                array(
                                    'Content-Type: application/json', $authorization,'nonce: '.$nonce
                                )
                            );
                            $formSubmitStatus = curl_exec($ch);
                            if($formSubmitStatus == false || $formSubmitStatus == 'false')
                            {
                                $formSubmitStatus = 'Application END Date Pass';
                            }
                            $query = "UPDATE applicant_declaration_payment SET paymentStatus='" . $status . "', receiptStatus='', txnId='" . $transactionId . "', formSubmissionStatus=1, applicationStatus = '".$formSubmitStatus."' WHERE id=" . $paymentId;
                            $update = mysqli_query($conn, $query);

                            $applicantjson='{"id":"'.$onlinePaymentId.'","txnid":"'.$transactionId.'","status":"'.$status.'"}';                                $options = array(
                                    'public_key' => $token->nonsec,
                                    'params' => '',
                                    'jsonData' => $applicantjson,
                                    'access_token' => isset($token->access_token)?$token->access_token:'',
                                );
                                $nonce = $ClassObject->secMe($options);
                            $ch = curl_init(baseURL . declarationPaymentUpdateStatus);
                            curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
                            curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);
                            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);

                            curl_setopt($ch, CURLOPT_POSTFIELDS, $applicantjson);
                            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                            curl_setopt($ch, CURLOPT_TIMEOUT, 120);
                            curl_setopt(
                                $ch,
                                CURLOPT_HTTPHEADER,
                                array(
                                    'Content-Type: application/json', $authorization,
                                    'Content-Length: ' . strlen($applicantjson),
                                    'nonce: '.$nonce
                                )
                            );

                            $resultcurl = curl_exec($ch);

                            $applicantjson_save='{"id":'.$onlinePaymentId.'}';
                                $options = array(
                                    'public_key' => $token->nonsec,
                                    'params' => '',
                                    'jsonData' => $applicantjson_save,
                                    'access_token' => isset($token->access_token)?$token->access_token:'',
                                );
                            $nonce = $ClassObject->secMe($options);
                            $ch1 = curl_init(baseURL . declarationPaymentCreateReceipt);
                            curl_setopt($ch1, CURLOPT_CUSTOMREQUEST, "POST");
                            curl_setopt($ch1, CURLOPT_POSTFIELDS, $applicantjson_save);
                            curl_setopt($ch1, CURLOPT_FOLLOWLOCATION, TRUE);
                            curl_setopt($ch1, CURLOPT_SSL_VERIFYPEER, false);
                            curl_setopt($ch1, CURLOPT_RETURNTRANSFER, true);
                            curl_setopt($ch1, CURLOPT_TIMEOUT, 120);
                            curl_setopt(
                                $ch1,
                                CURLOPT_HTTPHEADER,
                                array(
                                'Content-Type: application/json', $authorization,
                                'Content-Length: ' . strlen($applicantjson_save),
                                'nonce: '.$nonce
                                )
                            );

                            $resultcurl1 = curl_exec($ch1);
                            $responceERP1 = json_decode($resultcurl1);
                            $receiptId = $responceERP1;
                            if($receiptId && is_int($receiptId) && $receiptId > 0)
                            {
                                $query = "UPDATE applicant_declaration_payment SET receiptStatus='" . $status . "', receiptId = '".$receiptId."' WHERE id=" . $paymentId;
                                $update = mysqli_query($conn, $query);
                                echo '<div class="col-md-12 alert alert-success text-center">
                                        <h4>Fee Payment is successful !!!.<br /><br />Thank You!  Payment successfully of '.$currency.' '.$amount.'.<br><br> Please note your transaction ID '.$transactionId.' and Order Id '.$orderId.' for future reference.<br /> Please close the window.</h4>
                                    </div>';

                            }
                            else
                            {
                                echo '<div class="col-md-12 alert alert-success text-center">
                                        <h4>Fee Payment is successful !!!.<br /><br />Thank You!  Payment successfully of '.$currency.' '.$amount.' but a receipt is not generated in Academia.<br><br> Please note your transaction ID '.$transactionId.' and Order Id '.$orderId.' for future reference and contact institute administrator.<br /> Please close the window.</h4>
                                    </div>';
                            }

                            if($moduleId && $setupId)
                            {
                                $applicantjson = '{"application":{"id":'.$applicantId.'},"applicantPortalModules":{"id":'.$moduleId.'},"applicantPortalSetup":{"id":'.$setupId.'},"isFilled":true}';
                                $options = array(
                                    'public_key' => $token->nonsec,
                                    'params' => '',
                                    'jsonData' => $applicantjson,
                                    'access_token' => isset($token->access_token)?$token->access_token:'',
                                );
                                $nonce = $ClassObject->secMe($options);
                                $ch = curl_init(baseURL . portalLinkSaved);
                                curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
                                curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);
                                curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);

                                curl_setopt($ch, CURLOPT_POSTFIELDS, $applicantjson);
                                curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                                curl_setopt($ch, CURLOPT_TIMEOUT, 120);
                                curl_setopt(
                                    $ch,
                                    CURLOPT_HTTPHEADER,
                                    array(
                                    'Content-Type: application/json', $authorization,
                                    'Content-Length: ' . strlen($applicantjson),
                                    'nonce: '.$nonce
                                    )
                                );
                                $portalLinkSaveId = curl_exec($ch);
                                $query = "UPDATE applicant_declaration_payment SET portalLinkSaveId='" . $portalLinkSaveId . "' WHERE id=" . $paymentId;
                                $update = mysqli_query($conn, $query);
                            }
                        }
                        else
                        {
                            if($status != "TXN_SUCCESS" && $result['formSubmissionStatus'] != 1)
                            {
                                $query = "UPDATE applicant_declaration_payment SET paymentStatus='" . $status . "', receiptStatus='', txnId='" . $transactionId . "', formSubmissionStatus = 1 WHERE id=" . $paymentId;
                                $update = mysqli_query($conn, $query);
                            }
                            echo '<div class="col-md-12 alert alert-warning alert-dismissible fade show text-center">
                                    <h4>Unfortunately, Your transaction could not be processed. Please try again.</h4>
                                </div>';
                        }
                    }
                    else
                    {
                        echo '<div class="col-md-12 alert alert-warning alert-dismissible fade show text-center">
                            <h4>Invalid Payment Details. Please try again.</h4>
                        </div>';
                    }
                }
                else
                {
                    echo '<div class="col-md-12 alert alert-warning alert-dismissible fade show text-center">
                            <h4>Invalid Transaction. Please try again.</h4>
                        </div>';
                }
            }
            else
            {
                echo '<div class="col-md-12 alert alert-warning alert-dismissible fade show text-center">
                        <h4>Unfortunately, Your transaction could not be processed. Please try again.</h4>
                    </div>';
            }
        ?>
        <div class="col-md-12 text-center">
            <button class="btn btn-info" id="goToHomePage" onclick="goToHomePage()">Go to Home Page</button>
        </div>
        <div class="col-md-12  footer-main">
          <div class="footer-text">Copyright © <?php echo date('Y'); ?> Serosoft Solutions Pvt Ltd. All Rights Reserved.
          </div>
        </div>
        <script type="text/javascript">
            var baseUrl = '<?php echo baseURL; ?>';
            setTimeout(function() {
                document.getElementById("loader").style.display = 'none'
            },1000)
            function goToHomePage(){
                window.location.href = baseUrl+'/applicant-portal';
            }
        </script>
    </body>
</html>