<?php
/*
* import checksum generation utility
* You can get this utility from https://developer.paytm.com/docs/checksum/
*/
// following files need to be included
require_once("./lib/config_paytm.php");
require_once("PaytmChecksum.php");


$paramList = array();

$paramList["MID"] = '';
$paramList["ORDER_ID"] = '';
$paramList["CUST_ID"] = '';
$paramList["INDUSTRY_TYPE_ID"] = '';
$paramList["CHANNEL_ID"] = '';
$paramList["TXN_AMOUNT"] = '';
$paramList["WEBSITE"] = '';
$paramList["CALLBACK_URL"] = '';
// $paramList["MOBILE_NO"] = '';
// $paramList["EMAIL"] = '';

foreach ($_REQUEST as $key => $value) {
    $pos = strpos($value, $findme);
    $pospipe = strpos($value, $findmepipe);
    if ($pos === false || $pospipe === false) {
        $paramList[$key] = $value;
    }
}

$paytmParams = array();

$paytmParams["body"] = array(
    "requestType"   => "Payment",
    "mid"           => $paramList["MID"],
    "websiteName"   => $paramList["WEBSITE"],
    "orderId"       => $paramList["ORDER_ID"],
    "callbackUrl"   => $paramList["CALLBACK_URL"],
    "txnAmount"     => array(
        "value"     => $paramList["TXN_AMOUNT"],
        "currency"  => CURRENCY_CODE,
    ),
    "userInfo"      => array(
        "custId"    => $paramList["CUST_ID"],
    ),
);

/*
* Generate checksum by parameters we have in body
* Find your Merchant Key in your Paytm Dashboard at https://dashboard.paytm.com/next/apikeys 
*/
$checksum = PaytmChecksum::generateSignature(json_encode($paytmParams["body"], JSON_UNESCAPED_SLASHES), PAYTM_MERCHANT_KEY);

$paytmParams["head"] = array(
    "signature"    => $checksum
);

$post_data = json_encode($paytmParams, JSON_UNESCAPED_SLASHES);

/* for Staging */
$url = PAYTM_INITIATE_TXN . "?mid=" . $paramList["MID"] . "&orderId=" . $paramList["ORDER_ID"];

/* for Production */
// $url = "https://securegw.paytm.in/theia/api/v1/initiateTransaction?mid=".$paramList["MID"]."&orderId=".$paramList["ORDER_ID"];

$ch = curl_init($url);
curl_setopt($ch, CURLOPT_POST, 1);
curl_setopt($ch, CURLOPT_POSTFIELDS, $post_data);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_HTTPHEADER, array("Content-Type: application/json"));
$response = curl_exec($ch);
print_r($response);
